/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_editor.h 2 2005-04-17 13:24:23Z andrey $ */

#ifndef TV_EDITOR_H
#define TV_EDITOR_H

extern "C" {
#include "php.h"
}

#include "tv_common.h"
#define Uses_TEditor
#define Uses_TMemo
#define Uses_TKeys
#include <tvision/tv.h>

class TEditr : public TEditor
{
public:
    TEditr( const TRect& bounds,
                 TScrollBar *aHScrollBar,
                 TScrollBar *aVScrollBar,
                 TIndicator *aIndicator 
               );
	virtual Boolean setBufSize( uint newSize );
	void setData(void *rec);
	void handleEvent(TEvent&);
	void setReadOnly(bool value) {readOnly = value;}
	bool isReadOnly() {return readOnly;}
private:
	bool readOnly;
};

class TDlgEditor : public TEditr
{
public:
    TDlgEditor( const TRect& bounds,
                 TScrollBar *aHScrollBar,
                 TScrollBar *aVScrollBar,
                 TIndicator *aIndicator 
               );
	TPalette& getPalette() const;
	void setData(void *rec);
	void handleEvent(TEvent&);
	Boolean setBufSize( uint newSize );
};


TV_ALIASED_OBJECT(TEditor, TEditr)

TV_CE_INIT_D(TEditor);
PHP_METHOD(TEditor, __construct);
PHP_METHOD(TEditor, readOnly);


TV_ALIASED_OBJECT(TMemo, TDlgEditor)

TV_CE_INIT_D(TMemo);
PHP_METHOD(TMemo, __construct);

#endif // TV_EDITOR_H

