/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_event.cpp 2 2005-04-17 13:24:23Z andrey $ */

#include "tv_event.h"
#include "tv_registry.h"

zval *tevent_read_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
{
    zval tmp_member;
    zval *return_value;
    TV_OBJ(TEvent) *obj;

    obj = (TV_OBJ(TEvent) *)zend_objects_get_address(object TSRMLS_CC);

    if (member->type != IS_STRING) {
        tmp_member = *member;
        zval_copy_ctor(&tmp_member);
        convert_to_string(&tmp_member);
        member = &tmp_member;
    }

	if (strcmp(Z_STRVAL_P(member), "infoPtr") != 0) {
		MAKE_STD_ZVAL(return_value);
	}

    if (strcmp(Z_STRVAL_P(member), "what") == 0) {
		RETVAL_LONG(obj->obj->what);
	} else if (strcmp(Z_STRVAL_P(member), "x") == 0) {
		RETVAL_LONG(obj->obj->mouse.where.x);
	} else if (strcmp(Z_STRVAL_P(member), "y") == 0) {
		RETVAL_LONG(obj->obj->mouse.where.y);
	} else if (strcmp(Z_STRVAL_P(member), "eventFlags") == 0) {
		RETVAL_LONG(obj->obj->mouse.eventFlags);
	} else if (strcmp(Z_STRVAL_P(member), "controlKeyState") == 0) {
		RETVAL_LONG(obj->obj->mouse.controlKeyState);
	} else if (strcmp(Z_STRVAL_P(member), "buttons") == 0) {
		RETVAL_LONG(obj->obj->mouse.buttons);
	} else if (strcmp(Z_STRVAL_P(member), "keyCode") == 0) {
		RETVAL_LONG(obj->obj->keyDown.keyCode);
	} else if (strcmp(Z_STRVAL_P(member), "charCode") == 0) {
		RETVAL_LONG(obj->obj->keyDown.charScan.charCode);
	} else if (strcmp(Z_STRVAL_P(member), "scanCode") == 0) {
		RETVAL_LONG(obj->obj->keyDown.charScan.scanCode);
	} else if (strcmp(Z_STRVAL_P(member), "command") == 0) {
		RETVAL_LONG(obj->obj->message.command);
	} else if (strcmp(Z_STRVAL_P(member), "infoLong") == 0) {
		RETVAL_LONG(obj->obj->message.infoLong);
	} else if (strcmp(Z_STRVAL_P(member), "infoInt") == 0) {
		RETVAL_LONG(obj->obj->message.infoInt);
	} else if (strcmp(Z_STRVAL_P(member), "infoWord") == 0) {
		RETVAL_LONG(obj->obj->message.infoWord);
	} else if (strcmp(Z_STRVAL_P(member), "infoByte") == 0) {
		RETVAL_LONG(obj->obj->message.infoByte);
	} else if (strcmp(Z_STRVAL_P(member), "infoPtr") == 0) {
		return_value = tv_registry_get(obj->obj->message.infoPtr);
		if (!return_value) {
			MAKE_STD_ZVAL(return_value);
			RETVAL_NULL();
		}
	}

    if (member == &tmp_member) {
        zval_dtor(member);
    }
    return return_value;
} /* }}} */

zend_class_entry *tv_TEvent_class_entry;
static zend_object_handlers tevent_object_handlers;

ZEND_API zend_object_value tevent_objects_new(zend_class_entry *class_type TSRMLS_DC)/*{{{*/
{
    zend_object_value retval;
    TV_OBJ(TEvent) *intern;
    zval *tmp;
    intern = (TV_OBJ(TEvent) *)emalloc(sizeof(TV_OBJ(TEvent)));
    intern->ref = 0;
    intern->zo.ce = class_type;
    intern->zo.in_get = 0;
    intern->zo.in_set = 0;
    ALLOC_HASHTABLE(intern->zo.properties);
    zend_hash_init(intern->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(
        intern->zo.properties, &class_type->default_properties,
        (copy_ctor_func_t) zval_add_ref, (void *) &tmp, sizeof(zval *)
    );
	memcpy(&tevent_object_handlers, zend_get_std_object_handlers(), sizeof(zend_object_handlers));
    retval.handle = zend_objects_store_put(intern, NULL, NULL, NULL TSRMLS_CC);
    retval.handlers = &tevent_object_handlers;
	retval.handlers->read_property = tevent_read_property;
    return retval;
}/*}}}*/

void tv_init_tevent_ce() /*{{{*/
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TEvent", NULL);
    ce.create_object = tevent_objects_new;
    tv_TEvent_class_entry = zend_register_internal_class(&ce TSRMLS_CC);

}/*}}}*/

PHP_METHOD(TEvent, __construct) /* {{{ */
{
	TV_OBJ(TEvent)* obj;
	obj=(TV_OBJ(TEvent)*)zend_object_store_get_object(getThis());
    obj->obj = new TEvent;
} /* }}} */

PHP_METHOD(TEvent, __destruct) /* {{{ */
{
	TV_OBJ(TEvent)* obj;
	obj=(TV_OBJ(TEvent)*)zend_object_store_get_object(getThis());
    delete obj->obj;
} /* }}} */


/*
 *  * Local variables:
 *  * tab-width: 4
 *  * c-basic-offset: 4
 *  * End:
 *  * vim600: noet sw=4 ts=4 fdm=marker
 *  * vim<600: noet sw=4 ts=4
 *  */

