/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_msgbox.cpp 2 2005-04-17 13:24:23Z andrey $ */

/* includes {{{ */
extern "C" {
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
}
#include "tv_msgbox.h"
/* }}} */

PHP_FUNCTION(tvMessageBox)/*{{{*/
{
	char *msg;
	int msg_len;
	long options;

	msg = NULL;
	options = 0;
	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sl", &msg, &msg_len, &options);
	options = messageBox(msg, options);
	RETVAL_LONG(options);
}/*}}}*/

PHP_FUNCTION(tvInputBox)/*{{{*/
{
	char *title, *prompt, *input;
	int title_len, prompt_len;
	zval *ret;
	long options;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &title, &title_len, &prompt, &prompt_len, &ret) == FAILURE) {
		RETVAL_LONG(cmCancel);
		return;
	}
	convert_to_string(ret);
	input = (char*)emalloc(65536);
	memcpy(input, Z_STRVAL_P(ret), Z_STRLEN_P(ret) > 65535 ? 65535 : Z_STRLEN_P(ret));
	input[Z_STRLEN_P(ret) > 65535 ? 65535 : Z_STRLEN_P(ret)] = 0;
	options = inputBox(title, prompt, input, 65535);
	if (options != cmCancel) {
		zval_dtor(ret);
		ZVAL_STRING(ret, input, 1);
	}
	efree(input);
	RETVAL_LONG(options);
}/*}}}*/

/*
 * *  * Local variables:
 * *  * tab-width: 4
 * *  * c-basic-offset: 4
 * *  * End:
 * *  * vim600: noet sw=4 ts=4 fdm=marker
 * *  * vim<600: noet sw=4 ts=4
 * *  
*/

