/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_registry.cpp 2 2005-04-17 13:24:23Z andrey $ */

#include "tv_registry.h"

zend_llist tv_object_registry;

zval* tv_registry_get(void* infoPtr) /*{{{*/
{
	tv_object_registry_element *current;
	current = (tv_object_registry_element*)zend_llist_get_first(&tv_object_registry);
	while (current) {
		if (current->infoPtr == infoPtr) {
			return current->zobject;
		}
		current = (tv_object_registry_element*)zend_llist_get_next(&tv_object_registry);
	}
	return NULL;
}/*}}}*/

void tv_registry_put(void* infoPtr, zval *zobject) /*{{{*/
{
	tv_object_registry_element element;
	element.infoPtr = infoPtr;
	element.zobject = zobject;
	zend_llist_add_element(&tv_object_registry, &element);
}/*}}}*/

int tv_object_registry_element_compare (tv_object_registry_element *a, tv_object_registry_element *b)/*{{{*/
{
	return a->infoPtr == b->infoPtr;
}/*}}}*/

void tv_registry_del(void* infoPtr) /*{{{*/
{
	tv_object_registry_element element;
	element.infoPtr = infoPtr;
	zend_llist_del_element(&tv_object_registry, &element, (int (*)(void *, void *)) tv_object_registry_element_compare);
}/*}}}*/

void tv_registry_init()/*{{{*/
{
	zend_llist_init(&tv_object_registry, sizeof(tv_object_registry_element), NULL, 1);
}/*}}}*/

void tv_registry_done()/*{{{*/
{
	zend_llist_destroy(&tv_object_registry);
}/*}}}*/


/*
 *  * Local variables:
 *  * tab-width: 4
 *  * c-basic-offset: 4
 *  * End:
 *  * vim600: noet sw=4 ts=4 fdm=marker
 *  * vim<600: noet sw=4 ts=4
 *  
 */

