/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_stddlg.cpp 2 2005-04-17 13:24:23Z andrey $ */

/* includes {{{ */
extern "C" {
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
}
#include "tv_stddlg.h"
#include "tv_registry.h"
/* }}} */

extern TV_CLASS_ENTRY(TDialog);

/* TFileDialog declarations {{{ */
TV_CLASS_ENTRY(TFileDialog);
TV_CE_BEGIN(TFileDialog)
    PHP_ME(TFileDialog, __construct, NULL, ZEND_ACC_PUBLIC)
    PHP_ME(TFileDialog, getFileName, NULL, ZEND_ACC_PUBLIC)
TV_CE_END(TFileDialog)
TV_OBJECTS_NEW(TFileDialog)
TV_CE_INIT(TFileDialog, TV_CE(TDialog))
/* }}} */


PHP_METHOD(TFileDialog, __construct) /* {{{ */
{
	TV_OBJ(TFileDialog) *obj;
	char *wildcard, *title, *inputname;
	int  wildcardlen, titlelen, inputnamelen;
	long options, histid;

	histid = options = 0;
	wildcard = "*.*";
	title= "Open";
	inputname = "";

	zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sssll", &wildcard, &wildcardlen, &title, &titlelen, &inputname, &inputnamelen, &options, &histid);
	obj = (TV_OBJ(TFileDialog)*)zend_object_store_get_object(getThis());
	obj->obj = new TFileDialog( wildcard, title, inputname, options, histid );
	addref_and_store(obj);
}
/* }}} */

PHP_METHOD(TFileDialog, getFileName)/*{{{*/
{
	char name[PATH_MAX];
	TV_OBJ(TFileDialog) *obj;
	obj = (TV_OBJ(TFileDialog)*)zend_object_store_get_object(getThis());
	obj->obj->getFileName(name);
	RETVAL_STRING(name, 1);
	
}/*}}}*/

/*
 * *  * Local variables:
 * *  * tab-width: 4
 * *  * c-basic-offset: 4
 * *  * End:
 * *  * vim600: noet sw=4 ts=4 fdm=marker
 * *  * vim<600: noet sw=4 ts=4
 * *  
*/

