/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_table.h 2 2005-04-17 13:24:23Z andrey $ */

#ifndef TV_TABLE_H
#define TV_TABLE_H

extern "C" {
#include "php.h"
}

#include "tv_common.h"
#define Uses_TView
#define Uses_TEvent
#define Uses_TScrollBar
#define Uses_TKeys
#define Uses_TDrawBuffer
#include <tvision/tv.h>

class TTable : public TView
{
  public:
	TTable(zval *_thisptr, const TRect& bounds, TScrollBar *aHScrollBar, TScrollBar *aVScrollBar);
	~TTable();
	void handleEvent(TEvent& event);
	void draw();
	TPalette& getPalette() const;
	void setState(ushort, Boolean);
	int getSelectedRow();
	void selectItem(int);
  private:
	int getRowCount();
	int getColumnCount();
	int getColumnWidth(int);
	void getText(int, int, char*, int);
	void getColumnTitle(int, char*, int);
	zval *thisptr;
	TScrollBar *hsb, *vsb;
	int topItem;
	int selected;
	int rowCount;
	int xOffset;
};

TV_OBJECT(TTable)

TV_CE_INIT_D(TTable);
PHP_METHOD(TTable, __construct);
PHP_METHOD(TTable, getColumnCount);
PHP_METHOD(TTable, getColumnWidth);
PHP_METHOD(TTable, getRowCount);
PHP_METHOD(TTable, getText);
PHP_METHOD(TTable, getColumnTitle);
PHP_METHOD(TTable, getSelectedRow);
PHP_METHOD(TTable, selectRow);

#endif // ifndef TV_TABLE_H

