/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tv_view.h 2 2005-04-17 13:24:23Z andrey $ */

#ifndef TV_VIEW_H
#define TV_VIEW_H

extern "C" {
#include "php.h"
}

#define Uses_TEvent
#define Uses_TView
#define Uses_TGroup
#define Uses_TWindow
#define Uses_TDeskTop
#define Uses_TFrame

#include <tvision/tv.h>
#include "tv_common.h"

/* TView declarations {{{ */
TV_OBJECT(TView);
TV_CE_INIT_D(TView);
PHP_METHOD(TView, __construct);
PHP_METHOD(TView, __free);
PHP_METHOD(TView, moveTo);
PHP_METHOD(TView, growTo);
PHP_METHOD(TView, hide);
PHP_METHOD(TView, show);
PHP_METHOD(TView, focus);
PHP_METHOD(TView, hideCursor);
PHP_METHOD(TView, showCursor);
PHP_METHOD(TView, dataSize);
PHP_METHOD(TView, getData);
PHP_METHOD(TView, setData);
PHP_METHOD(TView, setCommandState);
PHP_METHOD(TView, commandEnabled);
PHP_METHOD(TView, execute);
PHP_METHOD(TView, endModal);
PHP_METHOD(TView, select);
PHP_METHOD(TView, makeFirst);
PHP_METHOD(TView, drawView);
PHP_METHOD(TView, options);
PHP_METHOD(TView, growMode);
PHP_METHOD(TView, clearEvent);
PHP_METHOD(TView, nextView);
PHP_METHOD(TView, getExtent);
PHP_METHOD(TView, getBounds);
PHP_METHOD(TView, message);
/* }}} */

/* TGroup declarations {{{ */
TV_OBJECT(TGroup);
TV_CE_INIT_D(TGroup);
PHP_METHOD(TGroup, __construct);
PHP_METHOD(TGroup, execView);
PHP_METHOD(TGroup, remove);
PHP_METHOD(TGroup, focusNext);
PHP_METHOD(TGroup, selectNext);
PHP_METHOD(TGroup, insert);
PHP_METHOD(TGroup, firstView);
/* }}} */

/* TDeskTop declarations {{{ */
TV_OBJECT(TDeskTop)
TV_CE_INIT_D(TDeskTop);
PHP_METHOD(TDeskTop, __construct);
PHP_METHOD(TDeskTop, cascade);
PHP_METHOD(TDeskTop, tile);
/* }}} */

/* TWindow declarations {{{ */

class TVWindow;

TV_ALIASED_OBJECT(TWindow, TVWindow)
TV_CE_INIT_D(TWindow);
PHP_METHOD(TWindow, __construct);
PHP_METHOD(TWindow, close);
PHP_METHOD(TWindow, zoom);
PHP_METHOD(TWindow, title);
/* }}} */


class TVWindow : public TWindow
{
  public:
	TVWindow(const TRect& bounds, const char *title, short number);
	TPalette& getPalette() const;
	void handleEvent(TEvent&);
};

#endif // TV_VIEW_H

/*
 *  * Local variables:
 *  * tab-width: 4
 *  * c-basic-offset: 4
 *  * End:
 *  * vim600: noet sw=4 ts=4 fdm=marker
 *  * vim<600: noet sw=4 ts=4
 *  */

