/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2005 Andrey Demenev                                    |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  Andrey Demenev <demenev@gmail.com>                          |
  +----------------------------------------------------------------------+
*/

/* $Id: tvision.cpp 3 2005-04-17 14:02:52Z andrey $ */

#include "php_tvision.h"

function_entry tvision_functions[] = { /* {{{ */
	PHP_FE(tvMessageBox, NULL)
	PHP_FE(tvInputBox, NULL)
	{NULL, NULL, NULL}
};
/* }}} */

zend_module_entry tvision_module_entry = { /* {{{ */
#if ZEND_MODULE_API_NO >= 20010901
	STANDARD_MODULE_HEADER,
#endif
	"tvision",
	tvision_functions,
	PHP_MINIT(tvision),
	PHP_MSHUTDOWN(tvision),
	PHP_RINIT(tvision),	
	PHP_RSHUTDOWN(tvision),
	PHP_MINFO(tvision),
#if ZEND_MODULE_API_NO >= 20010901
	"0.1",
#endif
	STANDARD_MODULE_PROPERTIES
};
/* }}} */

#ifdef COMPILE_DL_TVISION
extern "C" {
	ZEND_GET_MODULE(tvision)
}
#endif

extern TV_CLASS_ENTRY(TView);
extern TV_CLASS_ENTRY(TGroup);
extern TV_CLASS_ENTRY(TWindow);
extern TV_CLASS_ENTRY(TDialog);
extern TV_CLASS_ENTRY(TFileDialog);

void tv_register_constants(int type, int module_number TSRMLS_DC) /* {{{ */
{
	REGISTER_LONG_CONSTANT("cmValid",cmValid, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmQuit",cmQuit, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmError",cmError, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmMenu",cmMenu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmClose",cmClose, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmZoom",cmZoom, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmResize",cmResize, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmNext",cmNext, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmPrev",cmPrev, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmHelp",cmHelp, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmOK",cmOK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCancel",cmCancel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmYes",cmYes, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmNo",cmNo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmDefault",cmDefault, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmNew",cmNew, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmOpen",cmOpen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSave",cmSave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSaveAs",cmSaveAs, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSaveAll",cmSaveAll, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmChDir",cmChDir, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmDosShell",cmDosShell, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCloseAll",cmCloseAll, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSysRepaint",cmSysRepaint, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSysResize",cmSysResize, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSysWakeup",cmSysWakeup, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfVisible",sfVisible, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfCursorVis",sfCursorVis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfCursorIns",sfCursorIns, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfShadow",sfShadow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfActive",sfActive, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfSelected",sfSelected, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfFocused",sfFocused, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfDragging",sfDragging, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfDisabled",sfDisabled, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfModal",sfModal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfDefault",sfDefault, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sfExposed",sfExposed, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofSelectable",ofSelectable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofTopSelect",ofTopSelect, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofFirstClick",ofFirstClick, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofFramed",ofFramed, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofPreProcess",ofPreProcess, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofPostProcess",ofPostProcess, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofBuffered",ofBuffered, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofTileable",ofTileable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofCenterX",ofCenterX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofCenterY",ofCenterY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofCentered",ofCentered, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("ofValidate",ofValidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowLoX",gfGrowLoX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowLoY",gfGrowLoY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowHiX",gfGrowHiX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowHiY",gfGrowHiY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowAll",gfGrowAll, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfGrowRel",gfGrowRel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("gfFixed",gfFixed, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmDragMove",dmDragMove, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmDragGrow",dmDragGrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmLimitLoX",dmLimitLoX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmLimitLoY",dmLimitLoY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmLimitHiX",dmLimitHiX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmLimitHiY",dmLimitHiY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("dmLimitAll",dmLimitAll, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("hcNoContext",hcNoContext, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("hcDragging",hcDragging, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbLeftArrow",sbLeftArrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbRightArrow",sbRightArrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbPageLeft",sbPageLeft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbPageRight",sbPageRight, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbUpArrow",sbUpArrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbDownArrow",sbDownArrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbPageUp",sbPageUp, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbPageDown",sbPageDown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbIndicator",sbIndicator, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbHorizontal",sbHorizontal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbVertical",sbVertical, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("sbHandleKeyboard",sbHandleKeyboard, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wfMove",wfMove, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wfGrow",wfGrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wfClose",wfClose, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wfZoom",wfZoom, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noMenuBar",noMenuBar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noDeskTop",noDeskTop, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noStatusLine",noStatusLine, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noBackground",noBackground, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noFrame",noFrame, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noViewer",noViewer, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("noHistory",noHistory, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wnNoNumber",wnNoNumber, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wpBlueWindow",wpBlueWindow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wpCyanWindow",wpCyanWindow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("wpGrayWindow",wpGrayWindow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCut",cmCut, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCopy",cmCopy, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmPaste",cmPaste, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmUndo",cmUndo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmClear",cmClear, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmTile",cmTile, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCascade",cmCascade, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmReceivedFocus",cmReceivedFocus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmReleasedFocus",cmReleasedFocus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmCommandSetChanged",cmCommandSetChanged, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmScrollBarChanged",cmScrollBarChanged, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmScrollBarClicked",cmScrollBarClicked, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmSelectWindowNum",cmSelectWindowNum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmListItemSelected",cmListItemSelected, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("positionalEvents",positionalEvents, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("focusedEvents",focusedEvents, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlA", kbCtrlA, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlB", kbCtrlB, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlC", kbCtrlC, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlD", kbCtrlD, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlE", kbCtrlE, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF", kbCtrlF, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlG", kbCtrlG, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlH", kbCtrlH, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlI", kbCtrlI, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlJ", kbCtrlJ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlK", kbCtrlK, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlL", kbCtrlL, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlM", kbCtrlM, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlN", kbCtrlN, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlO", kbCtrlO, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlP", kbCtrlP, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlQ", kbCtrlQ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlR", kbCtrlR, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlS", kbCtrlS, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlT", kbCtrlT, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlU", kbCtrlU, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlV", kbCtrlV, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlW", kbCtrlW, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlX", kbCtrlX, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlY", kbCtrlY, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlZ", kbCtrlZ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbEsc", kbEsc, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltSpace", kbAltSpace, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlIns", kbCtrlIns, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftIns", kbShiftIns, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlDel", kbCtrlDel, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftDel", kbShiftDel, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbBack", kbBack, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlBack", kbCtrlBack, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftTab", kbShiftTab, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbTab", kbTab, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltQ", kbAltQ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltW", kbAltW, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltE", kbAltE, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltR", kbAltR, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltT", kbAltT, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltY", kbAltY, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltU", kbAltU, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltI", kbAltI, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltO", kbAltO, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltP", kbAltP, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlEnter", kbCtrlEnter, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbEnter", kbEnter, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltA", kbAltA, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltS", kbAltS, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltD", kbAltD, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF", kbAltF, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltG", kbAltG, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltH", kbAltH, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltJ", kbAltJ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltK", kbAltK, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltL", kbAltL, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltZ", kbAltZ, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltX", kbAltX, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltC", kbAltC, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltV", kbAltV, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltB", kbAltB, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltN", kbAltN, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltM", kbAltM, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF1", kbF1, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF2", kbF2, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF3", kbF3, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF4", kbF4, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF5", kbF5, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF6", kbF6, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF7", kbF7, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF8", kbF8, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF9", kbF9, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbF10", kbF10, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbHome", kbHome, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbUp", kbUp, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbPgUp", kbPgUp, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbGrayMinus", kbGrayMinus, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbLeft", kbLeft, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbRight", kbRight, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbGrayPlus", kbGrayPlus, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbEnd", kbEnd, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbDown", kbDown, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbPgDn", kbPgDn, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbIns", kbIns, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbDel", kbDel, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF1", kbShiftF1, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF2", kbShiftF2, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF3", kbShiftF3, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF4", kbShiftF4, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF5", kbShiftF5, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF6", kbShiftF6, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF7", kbShiftF7, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF8", kbShiftF8, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF9", kbShiftF9, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShiftF10", kbShiftF10, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF1", kbCtrlF1, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF2", kbCtrlF2, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF3", kbCtrlF3, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF4", kbCtrlF4, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF5", kbCtrlF5, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF6", kbCtrlF6, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF7", kbCtrlF7, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF8", kbCtrlF8, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF9", kbCtrlF9, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlF10", kbCtrlF10, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF1", kbAltF1, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF2", kbAltF2, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF3", kbAltF3, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF4", kbAltF4, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF5", kbAltF5, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF6", kbAltF6, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF7", kbAltF7, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF8", kbAltF8, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF9", kbAltF9, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltF10", kbAltF10, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlPrtSc", kbCtrlPrtSc, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlLeft", kbCtrlLeft, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlRight", kbCtrlRight, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlEnd", kbCtrlEnd, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlPgDn", kbCtrlPgDn, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlHome", kbCtrlHome, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt1", kbAlt1, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt2", kbAlt2, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt3", kbAlt3, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt4", kbAlt4, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt5", kbAlt5, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt6", kbAlt6, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt7", kbAlt7, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt8", kbAlt8, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt9", kbAlt9, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAlt0", kbAlt0, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltMinus", kbAltMinus, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltEqual", kbAltEqual, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlPgUp", kbCtrlPgUp, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltBack", kbAltBack, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbNoKey", kbNoKey, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbLeftShift", kbLeftShift, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbRightShift", kbRightShift, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbShift", kbShift, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbLeftCtrl", kbLeftCtrl, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbRightCtrl", kbRightCtrl, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCtrlShift", kbCtrlShift, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbLeftAlt", kbLeftAlt, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbRightAlt", kbRightAlt, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbAltShift", kbAltShift, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbScrollState", kbScrollState, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbNumState", kbNumState, CONST_CS | CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("kbCapsState", kbCapsState, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfWarning", mfWarning, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfError", mfError, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfInformation", mfInformation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfConfirmation", mfConfirmation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfYesButton", mfYesButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfNoButton", mfNoButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfOKButton", mfOKButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfCancelButton", mfCancelButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfYesNoCancel", mfYesNoCancel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mfOKCancel", mfOKCancel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("bfNormal", bfNormal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("bfDefault", bfDefault, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("bfLeftJust", bfLeftJust, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("bfBroadcast", bfBroadcast, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("bfGrabFocus", bfGrabFocus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmRecordHistory", cmRecordHistory, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdOKButton", fdOKButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdOpenButton", fdOpenButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdReplaceButton", fdReplaceButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdClearButton", fdClearButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdHelpButton", fdHelpButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("fdNoLoadDir", fdNoLoadDir, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMouseDown", evMouseDown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMouseUp", evMouseUp, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMouseMove", evMouseMove, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMouseAuto", evMouseAuto, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evKeyDown", evKeyDown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evCommand", evCommand, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evBroadcast", evBroadcast, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evNothing", evNothing, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMouse", evMouse, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evKeyboard", evKeyboard, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("evMessage", evMessage, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mbLeftButton", mbLeftButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("mbRightButton", mbRightButton, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("meMouseMoved", meMouseMoved, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("meDoubleClick", meDoubleClick, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("cmClusterChanged",cmClusterChanged, CONST_CS | CONST_PERSISTENT);
}
/* }}} */

PHP_MINIT_FUNCTION(tvision) /* {{{ */
{
    zend_class_entry ce;
	tv_registry_init();

	/* IMPORTANT!!! Keep these in correct order : init parent classes first */
	TV_INIT_CE(TRect);
	TV_INIT_CE(TNode);
	TV_INIT_CE(TMenuItem);
	TV_INIT_CE(TMenu);
	TV_INIT_CE(TSubMenu);
	TV_INIT_CE(TView);
	TV_INIT_CE(TInputLine);
	TV_INIT_CE(TProgressBar);
	TV_INIT_CE(TButton);
	TV_INIT_CE(TCheckBoxes);
	TV_INIT_CE(TRadioButtons);
	TV_INIT_CE(TScrollBar);
	TV_INIT_CE(TListBox);
	TV_INIT_CE(TStaticText);
	TV_INIT_CE(TOutline);
	TV_INIT_CE(TEditor);
	TV_INIT_CE(TMemo);
	TV_INIT_CE(TLabel);
	TV_INIT_CE(TGroup);
	TV_INIT_CE(TWindow);
	TV_INIT_CE(TDialog);
	TV_INIT_CE(THistory);
	TV_INIT_CE(TTable);
	TV_INIT_CE(TFileDialog);
    TV_INIT_CE(TDeskTop);
    TV_INIT_CE(TApplication);

	tv_init_tevent_ce();
	
	TV_CE(TView)->ce_flags |= ZEND_ACC_EXPLICIT_ABSTRACT_CLASS;
//	TV_CE(TGroup)->ce_flags |= ZEND_ACC_EXPLICIT_ABSTRACT_CLASS;

	tv_register_constants(INIT_FUNC_ARGS_PASSTHRU);
	return SUCCESS;
}
/* }}} */

PHP_MSHUTDOWN_FUNCTION(tvision) /* {{{ */
{
	tv_registry_done();
	return SUCCESS;
}
/* }}} */

PHP_RINIT_FUNCTION(tvision) /* {{{ */
{
	return SUCCESS;
}
/* }}} */

PHP_RSHUTDOWN_FUNCTION(tvision) /* {{{ */
{
	return SUCCESS;
}
/* }}} */

PHP_MINFO_FUNCTION(tvision) /* {{{ */
{
	php_info_print_table_start();
	php_info_print_table_header(2, "tvision support", "enabled");
	php_info_print_table_end();

}
/* }}} */

/*
 *  * Local variables:
 *  * tab-width: 4
 *  * c-basic-offset: 4
 *  * End:
 *  * vim600: noet sw=4 ts=4 fdm=marker
 *  * vim<600: noet sw=4 ts=4
 *  */

